%% M matrice con i dati exel sui test
%Facciamo variare Stiffness coefficienti e modulo elastico

function [coeff_f,S_correction_it,Er_f ,t] = Analyst_LOAD (M , Er_stimato, drift_correction, n_indent_cicliche, n_test,S_correction,n_interp_stiff,beta )

if S_correction==[]
S_correction(1,1000)=0;
end

epsilon=0.75;
Frame_stiffness=8100000;


%% Generazione dei row data

mat=struct('L',[],'D',[]);

%generazione carichi
for j=1:n_test
for i=1:n_indent_cicliche
mat(j,i).L=M(j,i).L + M(j,i).D .* M(j,i).SSS*10^-6;
end 
end

%generaione spostamenti
for j=1:n_test
for i=1:n_indent_cicliche
mat(j,i).D= M(j,i).D+ mat(j,i).L./(Frame_stiffness + S_correction)*10^6+ drift_correction(j)*M(j,i).T;
end 
end


%% stima di Er, assunzione:  un valore non variabile in base alla profondit e dunque costante lungo tutto lo spessore
%devo mettere in ingresso piu dati oppure andare a prelevarlo direttamete da testwork visto che l'ho calcolato 
Er_it=Er_stimato;

%%
%%
%%  INIZIO CICLO
%%
%% 
%%
n_iter_in=10;
for t=1:n_iter_in
%% Ricreo i DATAONSAMPLE che dipendono dalla stiffness correction, salvarli nella STRUTTURA M_it
% Con i valori calcolati di Stiffness correcton nuovi e valori area nuovi    
%La stiffness correction varia al variare dei cicli di ottimizzazione


%generaione spostamenti into the surface
for i=1:n_indent_cicliche
for j=1:n_test
      M_it(j,i,t).D= mat(j,i).D- mat(j,i).L./(Frame_stiffness+S_correction)*10^6 - drift_correction(j)*M(j,i).T;
end 
end


%generazione carichi
for i=1:n_indent_cicliche
for j=1:n_test
       M_it(j,i,t).L= mat(j,i).L- M_it(j,i,t).D.*M(j,i).SSS*10^-6;
end 
end



%% Creo la nuova STIFFNESS dai nuovi valori di spostamento e carico    
    
 for s=1:n_test
     for v=1:5
Stifness=polyfit(M_it(s,v,t).D(1:n_interp_stiff),M_it(s,v,t).L(1:n_interp_stiff),1);

S_c_it(s,v,t)=Stifness(1).*10^6;

     end
end
           
   S_c_it_m(t,:)=mean(S_c_it(:,:,t) );            
   
         
%% generazione dei nuovi valori di Stiffness correction

for v=1:n_indent_cicliche
    for k=1:n_test
          load_it1(k,v,t)=(M_it(k,v,t).L(2));              %in mN              
    end
end


sqrtload(:,:,t)=1./sqrt(load_it1(:,:,t));   %in mN^1/2
C_s(:,:,t)=1./S_c_it(:,:,t);               %in m/N


z=1;
for i=1:n_test
for j=1:5
sqrtload_v(z,1,t)=sqrtload(i,j,t);
z=z+1;
end
end

z=1;
for i=1:n_test
for j=1:5
C_s_v(z,1,t)=C_s(i,j,t);
z=z+1;
end
end

retta=polyfit(sqrtload_v(:,:,1),C_s_v(:,:,1),1);
yretta=polyval(retta,sqrtload_v);


sqrtload_v_t=sqrtload_v(:,:,t);
C_s_v_t=C_s_v(:,:,t);
yretta_t=yretta(:,:,t);

figure(2)
plot(sqrtload_v_t,yretta_t,sqrtload_v_t,C_s_v_t,'.')
title('Calibrazione Sfiffness Frame')
xlabel('1/sqrt(P)')
ylabel('1/S')
box off

if t==1
S_correction_it(t)=0;
end

S_correction_a=1/retta(2)- Frame_stiffness;               % calcolo della stiffness correction tramite grafico          
S_correction_it(t)=S_correction_a;
S_correction= S_correction_it(1); 
       
%generazione spostamenti into the surface con la STIFFNESS CORRECTION
for i=1:n_indent_cicliche
for j=1:n_test
      M_it(j,i,t).D= mat(j,i).D- mat(j,i).L./(Frame_stiffness+S_correction)*10^6 - drift_correction(j)*M(j,i).T;
end 
end


%generazione carichi
for i=1:n_indent_cicliche
for j=1:n_test
       M_it(j,i,t).L= mat(j,i).L- M_it(j,i,t).D.*M(j,i).SSS*10^-6;
end 
end



%% Creo la nuova STIFFNESS dai nuovi valori di spostamento e carico corretti dalla STIFFNESS CORRECTION   

 for s=1:n_test
     for v=1:5
Stifness=polyfit(M_it(s,v,t).D(1:n_interp_stiff),M_it(s,v,t).L(1:n_interp_stiff),1);

S_c_it(s,v,t)=Stifness(1).*10^6;

     end
end
           
   S_c_it_m(t,:)=mean(S_c_it(:,:,t) );            


%% determinazione della conctact depht   

for v=1:n_indent_cicliche
    for k=1:n_test
          load_it(k,v,t)=(M_it(k,v,t).L(2));              %in mN
          h_max_it(k,v,t)=(M_it(k,v,t).D(2));             %in nm
    end
end


for v=1:n_indent_cicliche
    for k=1:n_test

         h_cm(k,v,t)=(h_max_it(k,v,t)*10^-9) - epsilon*(load_it(k,v,t)*10^-3./S_c_it(k,v,t));  %in m

    end
end

h_c(:,:,t)=h_cm(:,:,t)*10^9;  


%% determinazione delle aree a diverse profondit

for i=1:n_test
    for j=1:n_indent_cicliche
        A_ff(i,j,t)=(pi.*S_c_it(i,j,t)^2)./(4*(Er_it)^2); 
    end
end


%% creazione array ordinati
k=1;
for i=1:n_test
for j=1:n_indent_cicliche
h_c_v(k,1)=h_c(i,j);
k=k+1;
end
end


p=1;
for i=1:n_test
for j=1:n_indent_cicliche
A_ff_v(p,1)=A_ff(i,j);
p=p+1;
end
end

%% determinazione di coefficienti di area che approssimano meglio i valori di area
% I nuovi coefficienti di area faranno variare il valore di modulo che lo calcolo alla fine e i valori di Stiffness 
AFunction=@(p1,p2,p3,p4,p5,x) p1*x.^2+ p2*x+ p3*x.^(1/2)+ p4*x.^(1/4)+ p5*x.^(1/8);

afittype=fittype(AFunction);

inizial_v=randi([0,100],1,5);
Limsup=Inf;
Liminf=Inf;
fo = fitoptions('Method','NonlinearLeastSquares','Lower',[24.5,-Liminf,-Liminf,-Liminf,-Liminf],'Upper',[24.5,Limsup,Limsup,Limsup,Limsup],'Normalize','off','StartPoint',[inizial_v],'Robust','Bisquare','MaxIter',[1000])

[A_function, errore, opzioni] = fit(h_c_v,A_ff_v,afittype, fo)


figure(1)
plot(A_function,h_c_v,A_ff_v,'.')
title('Calibrazione dei coefficienti della funzione Area')
ylabel('A(hc)')
xlabel('hc')
box off
coeff_f(t,:)= coeffvalues(A_function);

%% Generazione della nuova area
% definizione funzione. i coefficienti dovrei prelevarli da quelli calcolati nella funzione di fit

Function=@(h_c_v) coeff_f(t,1)*h_c_v^2+coeff_f(t,2)*h_c_v+coeff_f(t,3)*h_c_v^(1/2)+coeff_f(t,4)*h_c_v^(1/4)+coeff_f(t,5)*h_c_v^(1/8);


 for i=1:n_test
     for j=1:n_indent_cicliche
       A_it(i,j,t)=Function(h_c(i,j,t));   %valore in nm^2
     end
 end
 
 A_it_m(t)= mean(A_it(:,n_indent_cicliche,t));

%% generazione dei valori di MODULO RIDOTTO 


Er_it_tot= (sqrt(pi).*S_c_it)./(2.*beta.*sqrt(A_it(:,:,t)));
Er_it=mean(Er_it_tot(:,5,t));     %media ultimo ciclo
Er_f(t)= Er_it;

end  % Fine iterazioni per trovare la S_correction appropriata e Il valore di area approssimata Er variabile

end