%Algoritmo creato da Michele Belvedere, tesista magistrale di ingegneria
%biomedica 2018\2019.

close all
clear all
pack
clc

% valido per calibrazione sul silicio. Cambiare i parametri di v e E se
% viene effettuata su un altro materiale
% Quest algoritmo differisce da testworks solo nel calcolo della stifffness
% come algoritmo. Settare bene i punti su cui eseguire il calcolo della
% pendenza per avere un risultato idenico a quello di testworks. Oppure
% andare a calcolarlo in un altro modo. 

%% ATT: bisogna cambiare il valore di coeff di poisson, beta e epsilon inserendo quelli che vengo utilizzati anche nel calcolo sull'algoritmo di Textworks.

%% Definizione e caricamento delle variabili 
diamante=[1141,0.07];
silica=[72,0.18];

Sf_i=8100000;
A_in=zeros(6,1);

epsilon=0.75;
beta=1.034;           %Valore che bisognerebbe inserire per un indentatore Berkovich 
             
%% Input variabili e prelevazione dati. 
n_test= input('Inserire il numero di test effettuati:\n\n');                                                % tutti i punti su cui  calcolata la stiffness
S_correction= input('Inserire la Stiffness Correction:\n\n');
silica(2)=input('Inserire il coefficiente di Poisson del materiale (silica=0.18):\n\n');
beta=input('Inserire il coefficiente Beta (Berkovich=1.034; ISO=1):\n\n');
n_indent_cicliche=input('Inserire in numero di indentazioni cicliche:\n\n');
for m=1:5
fprintf('Inserire il %d coefficiente della funzione d area\n',m)
A_in(m,1) = input('Coefficiente: \n');
end

%numero di punti da prelevare nel tratto di scarico
n_punti= 42;  


% da decidere 
n_interp_stiff=14;
%% caricamento dati

[file1,path1]=uigetfile('*.xlsx','Load');
dati=xlsread(fullfile(path1,file1),'B3:F102');


%% Drift correction
drift_correction=dati(1:n_test,3);

    %% Prelevare i valori di S per le varie profondit e non le massime profondit e calcolo matrice indici
  if  n_indent_cicliche==1
    [M,I]=indici_singola(path1,file1,n_test,n_punti,n_indent_cicliche);
  else
     [M,I]=indici(path1,file1,n_test,n_punti,n_indent_cicliche); 
  end
  
%% generazione row data 

mat=struct('L',[],'D',[]);
  %generazione carichi
 
if n_indent_cicliche==1
    
for j=1:n_test
mat(j).L=M(j).L + M(j).D .* M(j).SSS*10^-6; 
end

%generaione spostamenti
for j=1:n_test
mat(j).D= M(j).D+ mat(j).L./(Sf_i)*10^6+ drift_correction(j)*M(j).T;
end
%% generazione dei dati affetti dalla stiffness correction 
%generaione spostamenti into the surface
for j=1:n_test
      M(j).D= mat(j).D- mat(j).L./(Sf_i+S_correction)*10^6 - drift_correction(j)*M(j).T;
end 
%generazione carichi
for j=1:n_test
       M(j).L= mat(j).L- M(j).D.*M(j).SSS*10^-6;
end 


else 
   
      
for j=1:n_test
for i=1:n_indent_cicliche
mat(j,i).L=M(j,i).L + M(j,i).D .* M(j,i).SSS*10^-6;
end 
end

%generaione spostamenti
for j=1:n_test
for i=1:n_indent_cicliche
mat(j,i).D= M(j,i).D+ mat(j,i).L./(Sf_i)*10^6+ drift_correction(j)*M(j,i).T;
end 
end
%% generazione dei dati affetti dalla stiffness correction 

%generaione spostamenti into the surface
for i=1:n_indent_cicliche
for j=1:n_test
      M(j,i).D= mat(j,i).D- mat(j,i).L./(Sf_i+S_correction)*10^6 - drift_correction(j)*M(j,i).T;
end 
end


%generazione carichi
for i=1:n_indent_cicliche
for j=1:n_test
       M(j,i).L= mat(j,i).L- M(j,i).D.*M(j,i).SSS*10^-6;
end 
end
 end

%% calcolo dei valori di Stiffness del provino nei n punti per ogni test
if  n_indent_cicliche==1 
for s=1:n_test
     
Stifness=polyfit(M(s).D(1:n_interp_stiff),M(s).L(1:n_interp_stiff),1);

S_c(s)=Stifness(1).*10^6; 
end

 else
     
for s=1:n_test
     for v=1:n_indent_cicliche
Stifness=polyfit(M(s,v).D(1:n_interp_stiff),M(s,v).L(1:n_interp_stiff),1);

S_c(s,v)=Stifness(1).*10^6;

     end
 end
 end
    
%% calcolo dei valori di spostamento per ogni zona. Prelevo il massimo spostamento effettuato per ogni zona. 
%Questo valore di spostamento massimo per ogni zona  rappresentato dal
%primo valore in cui avviene lo scarico.
if  n_indent_cicliche==1

    for k=1:n_test
          load(k)=(M(k).L(2));              %in mN
          h_max(k)=(M(k).D(2));             %in nm
    end
    
else
    
  for v=1:n_indent_cicliche
    for k=1:n_test

          load(k,v)=(M(k,v).L(2));              %in mN
          h_max(k,v)=(M(k,v).D(2));             %in nm
     
    end
  end
end


if  n_indent_cicliche==1
   
    for k=1:n_test

         h_cm(k)=h_max(k)*10^-9-epsilon*(load(k)*10^-3./S_c(k));  %in m

    end
else
for v=1:n_indent_cicliche
    for k=1:n_test

         h_cm(k,v)=h_max(k,v)*10^-9-epsilon*(load(k,v)*10^-3./S_c(k,v));  %in m

    end
end
end
h_c=h_cm*10^9;                        % in nm

%%
%%
%% Calcolo del valore di area alle diverse profondit

%l'area dipender anche dal valore della stiffness essendo che hc dipende
%da essa


A_function=@(h) A_in(1)*h^2+A_in(2)*h+A_in(3)*h^(1/2)+A_in(4)*h^(1/4)+A_in(5)*h^(1/8);
if  n_indent_cicliche==1
    for to=1:n_test
     
       A_hc(to)=A_function(h_c(to));   %valore in nm^2
  
    end
else
 for to=1:n_test
     for ti=1:n_indent_cicliche
       A_hc(to,ti)=A_function(h_c(to,ti));   %valore in nm^2
     end
 end
end
%% Calcolo modulo elasticit per le maggiori profondit

Er_hc=(S_c.*sqrt(pi))./(2*beta.*sqrt(A_hc));                               % Modulo Ridotto

E_sample=(1./Er_hc-(1-diamante(2)^2)/diamante(1)).^-1.*((1-silica(2)^2));  %Modulo Elastico


Er_silica=mean(E_sample(:,5)); 


H=(load./A_hc)*10^6;  % durezza


if  n_indent_cicliche==1
t=n_test;
for i=1:n_test
    E_e(t)=E_sample(i);
    t=t-1;
end
end

% errore=abs(dati(n_test,5)-E_e');

%% Ciclo analist per stima pi corretta della stiffness correction e della funzione d'area.

[coeff_analyst,S_correction_analyst,Er_analyst,n_iter_analyst]=Analyst_LOAD(M ,Er_silica,drift_correction ,n_indent_cicliche, n_test , S_correction,n_interp_stiff,beta)
% 
E_sample_analyst=(1./Er_analyst-(1-diamante(2)^2)/diamante(1)).^-1.*((1-silica(2)^2))        %Modulo Elastico nei vari cicli su analyst 

%------------------------------------------------------------------------------------------------
% Prove con altri metodi e altri parmetri, non prende in considerazione 
% for s=1:n_test
%     for v=1:5
%               S_c(s,v)=((M(s,v).L(2)-M(s,v).L(12))/(M(s,v).D(2)-M(s,v).D(12)).*10^6);   
%               %valore in N/m
%         
%     end
% end

% %% CALCOLO STIFFNESS, POWER LAW
% 
%  AFunction=@(p1,m,x) p1*x.^m;
% for s=1:n_test
%      for v=1:5
% afittype=fittype(AFunction);
% inizial_v1=abs(random('Normal',0,1000,[1]));
% inizial_v2=abs(random('Normal',0,2,[1]));
% fo = fitoptions('Method','NonlinearLeastSquares','Lower',[0,0],'Upper',[Inf,2],'Normalize','off','StartPoint',[inizial_v1,inizial_v2],'Robust','Bisquare','MaxIter',[1000])
% 
% [A_function, errore, opzioni] = fit(M(s,v).D(1:36),M(s,v).L(1:36),afittype, fo)
% P= coeffvalues(A_function);
%            
% Stifness= m*P(1)*(M(s,v).D(1)-M(s,v).D(36))^(P(2)-1);
% S_c(s,v)=Stifness.*10^6;
% 
%      end
% end

% %% calcolo della stiffness totale del sistema    
% S_f=8100000+S_correction;  % Stiffness frame totale
% 
% C_f=1/S_f;                 % Cedevolezza del frame
% C_cf=1./S_c;               % Cedevolezza del campione considerando anche la correction stiffness
% 
% 
% 
% C_t=C_cf+C_f;              % Cedevolezza totale del sistema
% S_cf=1./C_cf;              % Stiffness del campione senza correction stiffness
% 

% 
% fi=65.3; 
% % gamma1=pi*(pi/4+0.15483073*cot(fi*(1-2*silica(2))/(4*(1-silica(2)))))/(pi/2-0.83119312*cot(fi*(1-2*silica(2))/(4*(1-silica(2)))))^2;
% % %Non ho capito bene dove fossero le parentesi.
% % gamma2=pi*(pi/4+0.15483073*cot(fi)*(1-2*silica(2)/(4*(1-silica(2)))))/(pi/2-0.83119312*cot(fi)*(1-2*silica(2))/(4*(1-silica(2))))^2;
% % gamma=atan(sqrt(A_max)./((sqrt(pi))./Spost_max_zone));
% gamma3=1+ pi*(pi/4+0.1548*cot(fi*(1-2*silica(2)/(4*(1-silica(2))))))/(pi/2-0.8311*cot(fi*(1-2*silica(2))/(4*(1-silica(2)))))^2;

